#include <io.h>
#include <fcntl.h>
#include <graphics.h>
#include <conio.h>
#include <STRING.H>
#include <ALLOC.H>
#include <PROCESS.H>
#include <STDIO.H>
#include <dir.h>
#include "graton.hpp"
#include "image.hpp"


//
//          D E F I N I C I O N   D E   C O N S T A N T E S
//

#define BOTON_UP 0
#define BOTON_DOWN 1
#define BARRAX 10
	// "imag_sat.cpp"
#define BARRAY 10
#define ALTURA 35
#define NUM_BOTONES 5
#define MAX_BOTONES 5
#define NO_PULSADO   0
#define PULSADO      1
#define ACTIVO       0
#define INACTIVO     1
#define ICONO_TEXTO  0
#define ICONO_GRAF   1


//
//              D E F I N I C I O N   D E   T I P O S
//
// Tipo definido en "MAIN.CPP"
// Estructura para guardar la informacin de un botn
typedef struct
	{
	 long int xup;          // Los cuatro primeros campos permiten
	 long int yup;          // delimitar las dimensiones del botn
	 long int xdown;
	 long int ydown;
	 char estado;           // Los estados son PULSADO y NO_PULSADO
	 char activo;           // Puede tomar los valore ACTIVO e INACTIVO
	 char text_pict;        // Indica si le corresponde un icono de texto
							// o un icono grfico.
	 unsigned  long int pos_icono;  // Si se trata de un icono grfico indica
							// la posicin del icono dentro del fichero
	 char texto[20];        // Si es un icono de texto
	 char ayuda[100];       // Ayuda del boton
	}BOTON;


struct DACcolor
		{
		unsigned char R, G, B;
		};

int CORDX=0,CORDY=0;




//
//          D E F I N I C I O N   D E   P R O T O T I P O S
//


void boton_down(int xup,int yup,int tamx,int tamy,int grosor,int COLOR_BOTON);
void boton_up(int xup,int yup,int tamx,int tamy,int grosor,int COLOR_BOTON);
void activar_boton(int xup,int yup,int tamx,int tamy,int grosor);
void desactivar_boton(int xup,int yup,int tamx,int tamy,int grosor);
void dibujar_boton(int xup,int yup,int tamx,int tamy,int grosor,
				int COLOR_BOTON,int OPC);
void dibujar_boton2(int xup,int yup,int tamx,int tamy,int grosor,int COLOR_BOTON);
void sombrear_boton(int Num_boton,int grosor);
void init_botom(void);
void test_botones(void);
void inactivar_boton(BOTON boton);
void mensaje(char *texto);
void cargar_icono(int i,char *nombre);
void showTFE256 (int posx, int posy, unsigned char far *buffer,int tamx,int tamy);
int  gestion_boton(int *Ult_boton);
void test_boton(BOTON boton);
int boton_pulsado(BOTON far *botones,int Num_botones);
void bvd(void);
char Ventana_confirmacion(char *Titulo,char * Linea1,char *Linea2,char *Linea3);
void Ventana_errores(char * Linea1,char *Linea2,char *Linea3);
void mostrar_info(int xpant,int ypant);
void entrada(void); //"GRaton.cpp"
void poner_nombre_fich(void);


//
//                     F   U   N   C   I   O   N   E   S
//

//
// Funcin que dibuja un botn en pantalla, en el punto que se le pasa. Y con
// las dimensiones fijadas
//     OPC = 0 Botn desactivado
//     OPC = 1 Botn activado
//
void dibujar_boton(int xup,int yup,int tamx,int tamy,int grosor,
				int COLOR_BOTON,int OPC)
{
 extern GRaton raton;

// raton.OcultaCursor();
 if(OPC == BOTON_UP)
	 boton_up(xup,yup,tamx,tamy,grosor,COLOR_BOTON);
 else
	 if(OPC == BOTON_DOWN)
		 boton_down(xup,yup,tamx,tamy,grosor,COLOR_BOTON);
// raton.MuestraCursor();
}


void dibujar_boton2(int xup,int yup,int tamx,int tamy,int grosor,int COLOR_BOTON)
{
 setfillstyle(SOLID_FILL,COLOR_BOTON);
 bar(xup+grosor+3,yup+grosor+3, xup+tamx-grosor-2,yup+tamy-grosor-2);
}


void poner_nombre_fich(void)
	{
	 char buf[255];
	 extern char filename[MAXPATH];
	 dibujar_boton(320,BARRAY+8,300,35,2,LIGHTGRAY,1);
	 sprintf(buf,"Modelo : %s",filename);
	 settextjustify(LEFT_TEXT,TOP_TEXT);
	 setcolor(BLACK);
	 outtextxy(330, BARRAY+23,buf);
	}

//
// Dibuja un boton desactivado.
//
void boton_up(int xup,int yup,int tamx,int tamy,int grosor,
			 int COLOR_BOTON)
{
	int i;
	setfillstyle(SOLID_FILL,COLOR_BOTON);
	bar(xup,yup, xup+tamx,yup+tamy);

	for(i=1; i< grosor; i++)
	{
		 setcolor (WHITE);
		 line (xup+i,yup+i,xup+tamx-i,yup+i);
		 line (xup+i,yup,xup+i,yup+tamy-i);
		 setcolor(DARKGRAY);
		 line (xup+i,yup+tamy-i,xup+tamx,yup+tamy-i);
		 line (xup+tamx-i,yup+i,xup+tamx-i,yup+tamy);

	}
	 setcolor (BLACK);
	 line (xup,yup,xup+tamx,yup);
	 line (xup,yup,xup,yup+tamy);
	 line (xup,yup+tamy,xup+tamx,yup+tamy);
	 line (xup+tamx,yup,xup+tamx,yup+tamy);

}

//
// Dibuja un boton pulsado.
//
void boton_down(int xup,int yup,int tamx,int tamy,int grosor,
				int COLOR_BOTON)
{
	int i;
	setfillstyle(SOLID_FILL,COLOR_BOTON);
	bar(xup,yup, xup+tamx,yup+tamy);
	for(i=1; i< grosor; i++)
	{
		 setcolor (DARKGRAY);
		 line (xup+i,yup+i,xup+tamx-i,yup+i);
		 line (xup+i,yup,xup+i,yup+tamy-i);
		 setcolor(WHITE);
		 line (xup+i,yup+tamy-i,xup+tamx,yup+tamy-i);
		 line (xup+tamx-i,yup+i,xup+tamx-i,yup+tamy);
	}
	 setcolor (BLACK);
	 line (xup,yup,xup+tamx,yup);
	 line (xup,yup,xup,yup+tamy);
	 line (xup,yup+tamy,xup+tamx,yup+tamy);
	 line (xup+tamx,yup,xup+tamx,yup+tamy);

}

//
//    Sombrea un botn para dar la impresin de que est inactivo
//

void sombrear_boton(int Num_boton,int grosor)
{
	extern BOTON array_boton[17];
	int i,j;

	for(j= array_boton[Num_boton].yup+grosor+3;j<array_boton[Num_boton].ydown-grosor-3;j+=2)
	for(i= array_boton[Num_boton].xup+grosor+3;i<array_boton[Num_boton].xdown-grosor-3;i+=2)
		putpixel(i,j,BLACK);
}

//
//    Activar_boton pulsa el botn que se le indica
//

void activar_boton(int xup,int yup,int tamx,int tamy,int grosor)
{
	int i;
	extern GRaton raton;

	for(i=1; i< grosor; i++)
	{
		 setcolor (DARKGRAY);
		 line (xup+i,yup+i,xup+tamx-i,yup+i);
		 line (xup+i,yup,xup+i,yup+tamy-i);
		 setcolor(WHITE);
		 line (xup+i,yup+tamy-i,xup+tamx,yup+tamy-i);
		 line (xup+tamx-i,yup+i,xup+tamx-i,yup+tamy);
	}
	 setcolor (BLACK);
	 line (xup,yup,xup+tamx,yup);
	 line (xup,yup,xup,yup+tamy);
	 line (xup,yup+tamy,xup+tamx,yup+tamy);
	 line (xup+tamx,yup,xup+tamx,yup+tamy);

}

//
// Desactivar_boton desactiva un botn que estaba pulsado
//

void desactivar_boton(int xup,int yup,int tamx,int tamy,int grosor)
{
	int i;
	extern GRaton raton;

	for(i=1; i< grosor; i++)
	{
		 setcolor (WHITE);
		 line (xup+i,yup+i,xup+tamx-i,yup+i);
		 line (xup+i,yup,xup+i,yup+tamy-i);
		 setcolor(DARKGRAY);
		 line (xup+i,yup+tamy-i,xup+tamx,yup+tamy-i);
		 line (xup+tamx-i,yup+i,xup+tamx-i,yup+tamy);

	}
	 setcolor (BLACK);
	 line (xup,yup,xup+tamx,yup);
	 line (xup,yup,xup,yup+tamy);
	 line (xup,yup+tamy,xup+tamx,yup+tamy);
	 line (xup+tamx,yup,xup+tamx,yup+tamy);
}




//
//   bvd limpia la ventana donde se pintar la imagen cargada
//
void bvd(void)
{
 extern GRaton raton;

 raton.OcultaCursor();
 dibujar_boton(10,70,620,375,2,LIGHTGRAY,1);
 raton.MuestraCursor();
}


//
// 	Pinta la pantalla inicial de trabajo, con la distribucin de
// ventanas y botones.
//


void pantalla(void)
{
 int i,j;
 extern GRaton raton;

/*Fondo*/
 dibujar_boton(0,0,getmaxx(),getmaxy(),2,LIGHTGRAY,0);

/*Barra de botones*/
 dibujar_boton(BARRAX,BARRAY,620,ALTURA+16,2,LIGHTGRAY,0);

 for(i=0; i<NUM_BOTONES; i++)
	dibujar_boton(BARRAX+10+(ALTURA+5)*i,BARRAY+8,ALTURA,ALTURA,2,LIGHTGRAY,0);

//Barra de ayuda
 dibujar_boton(BARRAX,480 - 25,620,20, 2,LIGHTGRAY,1);

//Recuadro de la imagen
 dibujar_boton(BARRAX,70,620,375,2,LIGHTGRAY,1);
 init_botom();
 test_botones();
}


//
// Escribe un mensaje en la lnea de ayuda de la pantalla.
//
void mensaje(char *texto)
	{
	 extern GRaton raton;

	 setfillstyle(SOLID_FILL,LIGHTGRAY);
	 settextjustify(LEFT_TEXT,CENTER_TEXT);
	 setcolor(BLACK);
	 raton.OcultaCursor();
	 dibujar_boton(BARRAX,480 - 25,620,20, 2,LIGHTGRAY,1);
	 bar(BARRAX + 3  ,480-25+3,BARRAX+620 - 3,480-25+20-3);
	 outtextxy(BARRAX+8,480-15,texto);
	 raton.MuestraCursor();
	}


//
//  Inicializa los campos del array principal de botones.
//
void init_botom(void)
{
 extern BOTON array_boton[17];
 int i;

 // Botones del men principal

 for(i=0;i<10;i++)
	{
	 array_boton[i].xup=BARRAX+10+(ALTURA+5) * i;
	 array_boton[i].yup=BARRAY+8;
	 array_boton[i].xdown=array_boton[i].xup+ALTURA-1;
	 array_boton[i].ydown=array_boton[i].yup+ALTURA-1;
	 array_boton[i].estado= NO_PULSADO;
	 array_boton[i].activo= INACTIVO;
	 array_boton[i].text_pict= ICONO_TEXTO;
	 array_boton[i].pos_icono=i*900;
	 strcpy(array_boton[i].texto,"BOT");
	}
	for(i=0;i<5;i++)
		{
		 array_boton[i].activo= ACTIVO;
		}

 // Ayuda para los botones de la pantalla principal
 strcpy(array_boton[0].ayuda,"Operaciones de fichero (cargar, salvar,etc)");
 array_boton[0].text_pict = ICONO_GRAF;
 strcpy(array_boton[1].ayuda,"Operaciones con variables ( crear, modificar, fuzzificar, etc)");
 array_boton[1].text_pict = ICONO_GRAF;
 strcpy(array_boton[2].ayuda,"Ofrece los datos de una variable");
 array_boton[2].text_pict = ICONO_GRAF;
 strcpy(array_boton[3].ayuda,"Editar reglas");
 array_boton[3].text_pict = ICONO_GRAF;
 strcpy(array_boton[4].ayuda,"Simulacin del motor de inferencia");
 array_boton[4].text_pict = ICONO_GRAF;

 }

//
//     Esta funcin recorre el array de botones, dibujado segn los campos si
// el botn est pulsado o no, o si est INACTIVo. Adems de mostrar el icono
// grfico o de texto asociado al botn.
//

void test_botones(void)
{
 extern BOTON array_boton[17];
 int i;
 int temp;
 extern GRaton raton;

 for(i=0;i<MAX_BOTONES;i++)
	{
	 if(array_boton[i].activo!= INACTIVO)
		{
		 if(array_boton[i].estado== NO_PULSADO)       //El botn no est pulsado
			{
			 desactivar_boton(array_boton[i].xup,array_boton[i].yup,
			 array_boton[i].xdown-array_boton[i].xup,
			 array_boton[i].ydown-array_boton[i].yup,2);
			}
		 if(array_boton[i].text_pict==ICONO_TEXTO)    // Tiene un icono de texto
			 {

				temp=(array_boton[i].xup+array_boton[i].xdown)/2;
				setfillstyle(SOLID_FILL,LIGHTGRAY);
				bar(array_boton[i].xup+5,array_boton[i].yup+5,array_boton[i].xdown-5,array_boton[i].ydown-5);
				setcolor(RED);
				settextjustify(CENTER_TEXT,CENTER_TEXT);
				outtextxy(temp,(array_boton[i].yup+array_boton[i].ydown)/2,array_boton[i].texto);
			 }
		 else
			 {
				//  CARGAR ICONO
				cargar_icono(i,"iconos.dat");
			 }
		}
	 else
		// El botn est inactivo
		 {
		  inactivar_boton(array_boton[i]);
		 }
	}
}

//
//    Funcin que carga el icono grfico de fichero y lo pinta en el botn.
//
void cargar_icono(int N_boton,char *nombre)
{
 extern BOTON array_boton[17];
 int fich;
 unsigned TAMICONO,tamx,tamy;
 extern unsigned char far *buf1;
 extern GRaton raton;

 // Abre el fichero y se posiciona en el comienzo del icono.
 if ((fich = open(nombre, O_RDWR | O_BINARY )) == -1)
			perror("Error:");
 lseek(fich,(long) array_boton[N_boton].pos_icono, SEEK_SET);
 // Calcula las dimensiones del botn.
 tamy= array_boton[N_boton].ydown-array_boton[N_boton].yup-4;
 tamx= array_boton[N_boton].xdown-array_boton[N_boton].xup-4;
 TAMICONO= tamy*tamx;
 // Lee el icono del fichhero y cierra el fichero.
 _read(fich,buf1,TAMICONO);
 close ( fich );
 // Dibuja en pantalla el icono.
 showTFE256 (array_boton[N_boton].xup+3, array_boton[N_boton].yup+3,
			 buf1,tamx,tamy);
}


//
//	    Esta funcin dictamina si se ha pulsado un botn, retornando el botn
// pulsado  y mostrando la ayuda del  botn. En caso de que no se pulse nign
// botn testea si el cursor se encuentra sobre un botn,en cuyo caso muestra
// muestra la ayuda asociada.
//
int gestion_boton(int *Ult_boton)
{
 int posx,posy,i,tamx,tamy;
 int Boton_Pulsado=-1;
 int dondex,dondey; // Cordenadas de pantalla donde comienza la imagen
 extern BOTON array_boton[17];
 extern GRaton raton;
 extern int bi;
 extern int raton_boton;
 extern int cambio;

 posx = raton.PosicionHorizontal();
 posy = raton.PosicionVertical();
 // Calcula el botn sobre el que se encuentra el cursor
 for(i=0;i<17;i++)
	 if((posx<array_boton[i].xdown ) && (posx > array_boton[i].xup))
		{
		 if((posy <array_boton[i].ydown ) && (posy > array_boton[i].yup))
			 Boton_Pulsado=i;
		}
 // Si se encuentra sobre algn botn y est activo
 if ( cambio == 1)
 	{
   cambio = 0;
   raton_boton = (raton_boton + 5) % 5;
   raton.FijaPosicion(array_boton[raton_boton].xup+10,array_boton[raton_boton].yup+10 );
  }

 if((Boton_Pulsado != -1)&&(array_boton[Boton_Pulsado].activo != INACTIVO))
	{
	 if(bi)  // Se ha pulsado el botn izquierdo del ratn
		{
		 //Mostrar ayuda y pulsar boton
		 raton.OcultaCursor();
		 *Ult_boton= Boton_Pulsado;
		 tamy= array_boton[Boton_Pulsado].ydown-array_boton[Boton_Pulsado].yup;
		 tamx= array_boton[Boton_Pulsado].xdown-array_boton[Boton_Pulsado].xup;
		 activar_boton(array_boton[Boton_Pulsado].xup, array_boton[Boton_Pulsado].yup,
				tamx,tamy,2);
		 raton.MuestraCursor();
		 return Boton_Pulsado;
		}
	 else
		{
		 // No se ha pulsado nign botn del ratn,por lo que slo se muestra
		 // la ayuda.
		 // Si ese botn ya ha mostrado la ayuda, no se vuelve ha mostrar
		 if(Boton_Pulsado!=*Ult_boton)
			 {
			*Ult_boton= Boton_Pulsado;
			mensaje(array_boton[Boton_Pulsado].ayuda);
			 }
		 return -1;
		}
	}
 if(*Ult_boton != -1)
	{
	 mensaje(" ");
	 *Ult_boton = -1;
	}
 return -1;
}



void inactivar_boton(BOTON boton)
{
 int tamx,tamy;
 extern unsigned char far *buf1;
 extern GRaton raton;

 tamy= boton.ydown-boton.yup;
 tamx= boton.xdown-boton.xup;
 raton.OcultaCursor();
 setfillstyle(SOLID_FILL,LIGHTGRAY);
 bar(boton.xup,boton.yup,boton.xup+tamx,boton.yup+tamy);
 raton.MuestraCursor();
}

int boton_pulsado(BOTON far *botones,int Num_botones)
{
 extern GRaton raton;
 extern int bi,bd,bc;
 int posx,posy,i;

 posx = raton.PosicionHorizontal();
 posy = raton.PosicionVertical();
 if(bi)
	{
	 for(i=0;i<Num_botones;i++)
	   if((posx<botones[i].xdown ) && (posx > botones[i].xup))
		  {
		   if((posy < botones[i].ydown ) && (posy > botones[i].yup))
			   {
				activar_boton(botones[i].xup,botones[i].yup,
				botones[i].xdown-botones[i].xup,botones[i].ydown-botones[i].yup,2);
				return i;
			   }
		  }
	}
 return -1;
}





//=====================================================================
//        Este proceso testea el estado de un determinado boton
//=====================================================================

void test_boton(BOTON boton)
{
 int temp,tamx,tamy;
 extern GRaton raton;

 raton.OcultaCursor();
 tamx= boton.xdown-boton.xup;
 tamy= boton.ydown-boton.yup;
 dibujar_boton(boton.xup,boton.yup,tamx,tamy,2,LIGHTGRAY,0);
 if(boton.estado== NO_PULSADO)
	 desactivar_boton(boton.xup,boton.yup,tamx,tamy,2);
 else
	 activar_boton(boton.xup,boton.yup,tamx,tamy,2);
 if(boton.text_pict==ICONO_TEXTO)
	{
	 temp=boton.xup+tamx/2;
	 setcolor(BLACK);
	 settextjustify(CENTER_TEXT,CENTER_TEXT);
	 outtextxy(temp,boton.yup+tamy/2,boton.texto);
	}
 else
	{
	 //  CARGAR ICONO pasar posicion <<========================
	 // cargar_icono(i,"d:\\proyecto\\iconos\\icons.dat");
	}
 if(boton.activo== INACTIVO)
	{
	 inactivar_boton(boton);
	}
 raton.MuestraCursor();
}



//===================================================================
// Ventana de confirmacin
//===================================================================

char Ventana_confirmacion(char *Titulo,char * Linea1,char *Linea2,char *Linea3)
{
 extern GRaton raton;
 extern int bi,bd,bc;
 extern int raton_boton;
 extern int cambio;
 unsigned int TamMax=0,dimx=0,dimy=0;
 unsigned int orgx,orgy,NumLineas=0,posx,posy;
 extern unsigned char far *buf4;

 if(TamMax < strlen(Titulo)) TamMax = strlen(Titulo);
 if(TamMax < strlen(Linea1)) TamMax = strlen(Linea1);
 if(TamMax < strlen(Linea2)) TamMax = strlen(Linea2);
 if(TamMax < strlen(Linea3)) TamMax = strlen(Linea3);
 if(strlen(Linea1)!=0) NumLineas=1 ;
 if(strlen(Linea2)!=0) NumLineas=2 ;
 if(strlen(Linea3)!=0) NumLineas=3 ;

 if(TamMax>10)
	dimx= TamMax*8 + 60;
 else
	dimx=240;

 if ( dimx >400)
	dimx = 400;
 orgx= 320-dimx/2;
 dimy= 10+30+NumLineas*10+120;
 orgy= 100;
 raton.OcultaCursor();

 getimage(orgx,orgy,orgx+dimx+1,orgy+dimy+1,buf4);

 dibujar_boton(orgx,orgy,dimx,dimy,2,LIGHTGRAY,0);
 dibujar_boton(orgx+5,orgy+35,dimx-10,dimy-37,2,LIGHTGRAY,1);
 dibujar_boton(orgx+5,orgy+5,dimx-10,30,2,CYAN,1);

 settextstyle(0,0,1);
 setcolor(WHITE);
 settextjustify(CENTER_TEXT,TOP_TEXT);
 outtextxy(320, orgy+16,Titulo);
 setcolor(BLACK);
 setviewport(orgx+5,orgy,orgx+dimx-10,orgy+dimy,1);
 outtextxy(320-(orgx+5) ,44,Linea1);
 setviewport(orgx+5,orgy,orgx+dimx-10,orgy+dimy,1);
 outtextxy(320-(orgx+5),74,Linea2);
 setviewport(orgx+5,orgy,orgx+dimx-10,orgy+dimy,1);
 outtextxy(320-(orgx+5),104,Linea3);
 setviewport(0,0,getmaxx()-1,getmaxy()-1,1);
 dibujar_boton(260,orgy+dimy-50,30,20,2,LIGHTGRAY,0);
 dibujar_boton(350,orgy+dimy-50,30,20,2,LIGHTGRAY,0);
 setcolor(RED);
 outtextxy(275,orgy+dimy-44,"Si");
 outtextxy(365,orgy+dimy-44,"No");
 raton.MuestraCursor();
 raton_boton = 1;
 do
	{
	entrada();
  if ( cambio == 1)
  	{
     cambio = 0;
     raton_boton = (raton_boton + 2) % 2;
		 if ( raton_boton == 0)
       raton.FijaPosicion(275,orgy+dimy - 40);
		 if ( raton_boton == 1)
       raton.FijaPosicion(365,orgy+dimy - 40);
    }
	posx = raton.PosicionHorizontal();
	posy = raton.PosicionVertical();
	if((posy<orgy+dimy-10)&&(posy>orgy+dimy-50))
		{
		 if((posx<290)&&(posx>260)&&bi)
			{
			 raton.OcultaCursor();
			 activar_boton(260,orgy+dimy-50,30,20,2);

			 putimage(orgx,orgy,buf4,COPY_PUT);
			 raton.FijaLimites(0,0,getmaxx()-30,getmaxy());
			 raton.MuestraCursor();
			 return 1;
			}
		if((posx<380)&&(posx>350)&&bi)
			{
			 raton.OcultaCursor();
			 activar_boton(350,orgy+dimy-50,30,20,2);

			 putimage(orgx,orgy,buf4,COPY_PUT);
			 raton.FijaLimites(0,0,getmaxx()-30,getmaxy());
			 raton.MuestraCursor();
			 return 0;
			}
		}
	}
 while(!(bd));
 raton.OcultaCursor();
 putimage(orgx,orgy,buf4,COPY_PUT);
 raton.FijaLimites(0,0,getmaxx()-30,getmaxy());
 raton.MuestraCursor();
 return 0;
}

//===================================================================
// Ventana de errores
//===================================================================

void Ventana_errores(char * Linea1,char *Linea2,char *Linea3)
{
 extern GRaton raton;
 extern int bi,bd,bc;
 unsigned int dimx=0,dimy=0;
 unsigned int orgx,orgy;
 extern unsigned char far *buf4;
 unsigned char far *buftemp;

 int fich;


 orgx=170;
 orgy=60;
 dimx=300;
 dimy=100;
 raton.OcultaCursor();
 getimage(orgx,orgy,orgx+dimx,orgy+dimy,(buf4));
 dibujar_boton(orgx,orgy,dimx,dimy,2,LIGHTGRAY,0);
 dibujar_boton(orgx+5,orgy+35,dimx-10,dimy-38,2,LIGHTGRAY,1);
 dibujar_boton(orgx+5,orgy+5,dimx-10,30,2,CYAN,1);

 settextstyle(0,0,1);
 setcolor(WHITE);
 settextjustify(CENTER_TEXT,TOP_TEXT);
 outtextxy(320,orgy+16,"E R R O R");

 setcolor(BLACK);
 outtextxy(320,orgy+40,Linea1);
 outtextxy(320,orgy+60,Linea2);
 outtextxy(320,orgy+80,Linea3);
 raton.MuestraCursor();
 do
  {
	entrada();
  }
 while(!(bd));
 bd = bi=bc = 0;

 raton.OcultaCursor();
 putimage(orgx,orgy,buf4,COPY_PUT);
 raton.MuestraCursor();
}


void showTFE256 (int posx, int posy, unsigned char far *buffer,int tamx,int tamy)
	{
	 int x, y;
	 for ( x = 0; x <  tamx; x++)
		for ( y =0; y < tamy; y++)
			{
			 putpixel(posx+x,posy+y,*(buffer+x+y*tamy));
			}

	}



