#include <graphics.h>
#include <dos.h>
#include <stdio.h>
#include <math.h>

#define READDAC 	0x03c7
#define WRITEDAC 	0x03c8
#define DAC		    0x03c9

#define strcat _fstrcat
#define strcmp _fstrcmp
#define strcpy _fstrcpy
#define strlen _fstrlen

void setcolorRGB (int color, int R, int G, int B);

/* Estructura donde se almacenarn los registros de los colores */
struct DACcolor
		{
		unsigned char R, G, B;
		};



struct DACcolor paleta[256]; // estructura donde se guarda la paleta activa

char paldefault[48] = { 0,  0,  0,
						0,  0,  42,
						0,  42, 0,
						21, 30, 21,
						42, 0,  0,
						42, 0,  42,
						42, 21, 0,
						42, 42, 42,
						21, 21, 21,
						21, 21, 63,
						21, 63, 21,
						21, 63, 63,
						63, 21, 21,
						63, 21, 63,
						63, 63, 21,
						63, 63, 63
						};

void paletagris(void)
{
   int i,j;
   double inc, color = 0;


   outportb (WRITEDAC, 0);
   for ( j = 0,i = 0 ; i <  16; i ++, j += 3)
		 {
		  outportb (DAC,paldefault[j] );
		  outportb (DAC, paldefault[j+1]);
		  outportb (DAC, paldefault[j+2]);
		  paleta[i]. R = paldefault[j];
		  paleta[i]. G = paldefault[j+1];
		  paleta[i]. B = paldefault[j+2];
		 }

   inc = ((double) 63) / ( (double) 240);
   for (i=16; i<256; i++, color += inc)
	{
	 j = ceil(color);
	 outportb (DAC, j );
	 outportb (DAC, j);
	 outportb (DAC, j);
	 paleta[i]. R = j;
	 paleta[i]. G = j;
	 paleta[i]. B = j;
	}

}


void paletacolor( struct DACcolor colores[])
	{
	 int i;
	 for (i=0; i<256; i++)
	  {
	   setcolorRGB(i, colores[i].R,colores[i].G,colores[i].B);
	  }
	}

void getpaleta(struct DACcolor paletaCOL[])
	{
	unsigned color;
	outportb (READDAC, 0);
	for (color = 0; color < 256; color++)
		{
		 paletaCOL[color].R = inportb (DAC);
		 paletaCOL[color].G = inportb (DAC);
		 paletaCOL[color].B = inportb (DAC);
		} /* Fin for color */
	}

void setpaleta(struct DACcolor *pal)
	{
	 int color= 0;


	 outportb (WRITEDAC, 0);
	 for ( color = 0; color <256 ; color++)
		{
		 outportb (DAC, pal[color].R);
		 outportb (DAC, pal[color].G);
		 outportb (DAC, pal[color].B);
		}
	}



/* Pone un color determinado con unas intensidades RGB especificadas */
void setcolorRGB (int color, int R, int G, int B)
	{

	outportb (WRITEDAC, color);
	outportb (DAC, R);
	outportb (DAC, G);
	outportb (DAC, B);
	}

/* Recoge las intensidades RGB de un color especificado */
void getcolorRGB (int color, int *R, int *G, int *B)
	{

	outportb (READDAC, color);
	*R = inportb (DAC);
	*G = inportb (DAC );
	*B = inportb (DAC);
	}

