  /* Tipos de variables */
#define ENTRADA 1
#define SALIDA  2

  /* tipos de conjuntos */	
#define TRIANGULAR 1
#define TRAPEZOIDAL 2

  /* Operadores posibles*/
#define AND 1
#define OR  2
#define NOT 3
#define EQ  4
#define PER 5

typedef struct per
	{
	 double grado;
	 struct per *next;
	} lista_per ;  /* Estrcutura para mantener una lista con todos los grados 
							de pertenencia a un cnj de una vble de salida */

typedef struct cnj
	{
	 char nombre[255] ; /* Identificador del cnj */
	 char tipo;         /* Forma del cnj Fuzzy ( tiangular o trapezaoidal ) */
	 double left ;      /* Lmite inferior del cnj */
	 double right;      /* Lmite superior del cnj */
	 double top_left ;  /* Vertice superior izquierdo del cnj */
	 double top_right ; /* Vertice superior derecho del cnj */
	 double grado_pertenencia ; /* Guarda en un momento dado el grado de 
											 pertenencias de un variable
											 al cnj, es decir cuando para un valor 
											 determinado de la vble se concule su grado de
											 pertenencia al cnj se guardar en este campo
											 y a partir de el se realizarn las inferencias
										 */   
	 lista_per *ptr_lista;  /* lista para mantener los grados de pertenencia
										de una vble de salida */
	 struct cnj *next, *last; /* Punteros para poder mantener una lista 
									 doblemente enlazada de los cnj de una vble */
	 double area;   /* Area total del conjunto */
	 double px ;    /* Resultado de INTEGRAL(P(x) * x dx) */

	} cnj_fuzzy;


/* Estructura para mantener la informacin referente a un vble en el sistema*/
typedef struct variable
	{
	 char nombre[255]; /* 255 caracter para guardar un nombre significativo
						  para la vble */
	 char tipo;  /* Determina si la vble es de salida o de entrada */
	 double min;
	 double max ; /* Rango de valores que puede tomar la vble */
	 cnj_fuzzy *conjuntos; /* Puntero para direccionar el comienxo de una 
										lista enlazada con todos los conjuntos.*/
	 struct variable *next; /* Para mantener una lista con las variable del 
								sistema */
	 char fichero[255]; /* para almacenar el nombre del fichero de donde 
									  se tomarn los datos */	
	} vble;

	

/* Cada regla se guardar en una estructura de rbol */
typedef struct reg
	{
	 char operador; /* Indica en tipo de operacin que se debe ejecutar en 
										 en cada nodo */
	 union nodo
		{
		 struct nohoja /* Estructura en caso de que no se trate de un nodo hoja */
			{
			 struct reg *izq,*der ;  /* punteros para mantener una estructura de arbol */
			} nohoja;
		 struct hoja  /* Estructura en caso de que se trate de un nodo hoja */
			{
			 vble *variable; /* puntero a la vble en cuestin*/
			 cnj_fuzzy *cnj;  /* puntero al cnj que debe pertenecer */
			} hoja ;
		} nodo;
	}  regla;

/* Estructura para mantener una lista de reglas en memoria */
typedef struct lis_reg
	{
	 regla *reg;
	 struct lis_reg *next;
	} lis_reg;
